package com.adc.da.bs.cloudbackup.dao;

import java.math.BigDecimal;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import org.apache.commons.lang3.StringUtils;
import org.hibernate.transform.Transformers;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.jdbc.core.BatchPreparedStatementSetter;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

import com.adc.da.base.entity.BaseEntity;
import com.adc.da.bs.cloudbackup.entity.QJTJB;
import com.adc.da.bs.cloudbackup.entity.QJTJB_INFO;
import com.adc.da.util.exception.AdcDaBaseException;
import com.adc.da.util.http.PageParam;


@Component
public class QjtjbDao extends  BaseEntity{
	protected final EntityManager entityManager;
    @Autowired
    public QjtjbDao(EntityManager entityManager) {
        super();
        this.entityManager = entityManager;
    }
    @Autowired
    private JdbcTemplate jdbcTemplate;

    /**
     * 分页并按上传日期（降序）显示所有记录
     * @param page
     * @param rkEndTime 
     * @param rkStartTime 
     * @return
     */
    public List<Map<String,Object>> findAllByPage(PageParam page,String cpxh, String cpmc, String pc, String qyid,String confirm,String sblb,String jcejg,String isnew ){
    	StringBuffer sql = new StringBuffer();
//    sql.append(" SELECT ID,CPXH,PC,CPMC,SBLX,JCEJGNAME,QJTJB_MC,QJTJB_NEW_MC,QJTJB_ID,QJTJB_NEW_ID,CREATE_TIME,QY_ID,CONFIRM,CONFIRM_TIME,DEL_FLAG,ISNEW,'NEW' AS FLAG   ");
//	sql.append(" SELECT  G.* ");
	sql.append(" SELECT  G.ID,G.CPXH,G.PC,G.CPMC,G.SBLX,G.JCEJGNAME,G.QJTJB_MC,G.QJTJB_NEW_MC,G.QJTJB_ID,G.QJTJB_NEW_ID,G.CREATE_TIME,G.QY_ID,G.CONFIRM,TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') as CONFIRM_TIME,G.DEL_FLAG,G.ISNEW ");
    	sql.append(" FROM NERDS.Qjtjb G ");
    	sql.append(" WHERE G.QY_ID= '"+qyid+"'");   
     	if(cpxh!=null && !"".equals(cpxh.trim())){
        	sql.append(" AND CPXH like concat(concat('%',:cpxh),'%')  ");    		
    	}
     	if(cpmc!=null && !"".equals(cpmc.trim())){
        	sql.append(" AND ( CPMC like concat(concat('%',:cpmc),'%')) ");    		
    	}
    	if(sblb!=null && !"".equals(sblb)){
        	sql.append(" AND SBLX=:sblb ");    		
    	}
    	if(pc!=null && !"".equals(pc)){
        	sql.append(" AND PC=:pc ");    		
    	}
    	if(jcejg!=null && !"".equals(jcejg.trim())){
    		sql.append(" AND JCEJGNAME=:jcejg ");    		
    	} 
    	if(confirm!=null && "1".equals(confirm)){
        	sql.append(" AND CONFIRM='1' ");    		
    	}
    	if(confirm!=null && "0".equals(confirm)){
        	sql.append(" AND (CONFIRM ='0' or CONFIRM is null) ");    		
    	}
    	if(isnew!=null && "Y".equals(isnew)){
        	sql.append(" AND ISNEW='Y' ");    		
    	}
    	if(isnew!=null && "N".equals(isnew)){
        	sql.append(" AND (ISNEW ='N' or ISNEW is null) ");    		
    	} 
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') >=:qrStartTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') <=:qrEndTime ");
		} 
    	sql.append(" ORDER BY G.CREATE_TIME DESC ");
    	
    	Query query = entityManager.createNativeQuery(sql.toString());
    	if(cpxh!=null && !"".equals(cpxh.trim())){
    		query.setParameter("cpxh", cpxh);
    	}
    	if(cpmc!=null && !"".equals(cpmc.trim())){
    		query.setParameter("cpmc", cpmc);
    	}
    	if(pc!=null && !"".equals(pc.trim())){
    		query.setParameter("pc", pc);
    	}
    	if(jcejg!=null && !"".equals(jcejg.trim())){
    		query.setParameter("jcejg", jcejg);
    	}
    	if(sblb!=null && !"".equals(sblb.trim())){
    		query.setParameter("sblb", sblb);
    	}
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			query.setParameter("qrStartTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			query.setParameter("qrEndTime", page.getEndTime());
		}  
		
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
    	query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }
    
    
    public List<Map<String,Object>> findHistoryAllByPage(PageParam page,String cpxh, String cpmc, String pc, String qyid,String confirm,String sblb,String jcejg,String isnew ){
    	StringBuffer sql = new StringBuffer();
//    sql.append(" SELECT ID,CPXH,PC,CPMC,SBLX,JCEJGNAME,QJTJB_MC,QJTJB_NEW_MC,QJTJB_ID,QJTJB_NEW_ID,CREATE_TIME,QY_ID,CONFIRM,CONFIRM_TIME,DEL_FLAG,ISNEW,'new' AS FLAG,'' AS CPLB   ");
	sql.append(" SELECT ID,CPXH,PC,CPMC,SBLX,JCEJGNAME,QJTJB_MC,QJTJB_NEW_MC,QJTJB_ID,QJTJB_NEW_ID,CREATE_TIME,QY_ID,CONFIRM,TO_CHAR(CONFIRM_TIME, 'YYYY-MM-DD') as CONFIRM_TIME,DEL_FLAG,ISNEW,'new' AS FLAG,'' AS CPLB   ");

    	//    	sql.append(" SELECT  G.* ");
    	sql.append(" FROM NERDS.Qjtjb G ");   
    	sql.append(" WHERE G.QY_ID= '"+qyid+"'");   
     	if(cpxh!=null && !"".equals(cpxh.trim())){
        	sql.append(" AND CPXH like concat(concat('%',:cpxh),'%')  ");    		
    	}
     	if(cpmc!=null && !"".equals(cpmc.trim())){
        	sql.append(" AND ( CPMC like concat(concat('%',:cpmc),'%')) ");    		
    	}
    	if(sblb!=null && !"".equals(sblb)){
        	sql.append(" AND SBLX=:sblb ");    		
    	}
    	if(pc!=null && !"".equals(pc)){
        	sql.append(" AND PC=:pc ");    		
    	}
    	if(jcejg!=null && !"".equals(jcejg.trim())){
    		sql.append(" AND JCEJGNAME=:jcejg ");    		
    	} 
    	if(confirm!=null && "1".equals(confirm)){
        	sql.append(" AND CONFIRM='1' ");    		
    	}
    	if(confirm!=null && "0".equals(confirm)){
        	sql.append(" AND (CONFIRM ='0' or CONFIRM is null) ");    		
    	}
    	if(isnew!=null && "Y".equals(isnew)){
        	sql.append(" AND ISNEW='Y' ");    		
    	}
    	if(isnew!=null && "N".equals(isnew)){
        	sql.append(" AND (ISNEW ='N' or ISNEW is null) ");    		
    	} 
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') >=:qrStartTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') <=:qrEndTime ");
		} 
    	//sql.append(" ORDER BY G.CREATE_TIME DESC ");
    	
		//只有定制版企业才显示338批次之前的统计表数据 TODO 
		//根据企业ID查询企业的版本号
		String sql_temp = "select VERSION_ID from retrieval.ret_users where username =:username ";
		Query queryTemp = entityManager.createNativeQuery(sql_temp.toString());
    	if(qyid!=null && !"".equals(qyid.trim())){
    		queryTemp.setParameter("username", qyid);
    	}
    	queryTemp.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
//    	queryTemp.setFirstResult(page.getOffset());
//    	queryTemp.setMaxResults(page.getLimit());
    	BigDecimal viserID = null;
        List<Map<String, Object>> listTemp = queryTemp.getResultList();
        if(listTemp.size()>0){
        	 viserID = (BigDecimal) listTemp.get(0).get("VERSION_ID");
        }
        System.out.println(viserID);
        
    	if(null!= viserID && viserID.intValue() > 10){
    		
    		//新增历史统计表（338之前的）
        	sql.append(" UNION ALL ");
//        	sql.append("  SELECT ZK.ID, ZK.CPXH,ZK.PC,ZK.CPMC,  CASE WHEN ZK.TBTYPE = 'qjtjb'THEN '新产品'WHEN ZK.TBTYPE ='kwkz'THEN '变更扩展' END SBLX ,JCE.NAME AS JCEJGNAME, '' AS QJTJB_MC,'' AS QJTJB_NEW_MC, '' AS QJTJB_ID, '' AS QJTJB_NEW_ID, ZK.TJSJ AS CREATE_TIME, ZK.QY_ID QY_ID,'1' AS CONFIRM,ZK.TJSJ AS CONFIRM_TIME,'0' AS DEL_FLAG, ISNEW ,'history' AS FLAG,USERNAME AS CPLB  ");
		sql.append("  SELECT ZK.ID, ZK.CPXH,ZK.PC,ZK.CPMC,  CASE WHEN ZK.TBTYPE = 'qjtjb'THEN '新产品'WHEN ZK.TBTYPE ='kwkz'THEN '变更扩展' END SBLX ,JCE.NAME AS JCEJGNAME, '' AS QJTJB_MC,'' AS QJTJB_NEW_MC, '' AS QJTJB_ID, '' AS QJTJB_NEW_ID, ZK.TJSJ AS CREATE_TIME, ZK.QY_ID QY_ID,'1' AS CONFIRM, TO_CHAR(ZK.TJSJ, 'YYYY-MM-DD') as CONFIRM_TIME,'0' AS DEL_FLAG, ISNEW ,'history' AS FLAG,USERNAME AS CPLB  ");
		sql.append(" FROM GGCAIN06.JCE_COMMINFO_ZK ZK ");
        	sql.append(" LEFT JOIN (SELECT ID, DXBGBH FROM GGCAIN06.JCE_COMMINFO_ZK WHERE TBTYPE = 'DXBG') DX ");
        	sql.append(" ON DX.ID = ZK.ID ");
        	sql.append(" LEFT JOIN GGCAIN06.JCEJG JCE ");
        	sql.append(" ON ZK.USERNAME = JCE.USERNAME ");
        	sql.append(" WHERE 1=1 AND TBTYPE IN ('qjtjb','kwkz') ");
        	sql.append(" AND QYMC LIKE '%%' ");
        	
        	if(!"adc".equals(qyid)){
        	sql.append(" AND (USERNAME = '"+qyid+"' ");
        	sql.append(" OR QY_ID      = '"+qyid+"')");
        	}
        	
        	//添加338及以后批的筛选条件
        	if(pc!=null && !"".equals(pc)){
            	sql.append(" AND PC=:oldpc ");    		
        	}  	
         	if(cpxh!=null && !"".equals(cpxh.trim())){
            	sql.append(" AND CPXH like concat(concat('%',:oldcpxh),'%')  ");    		
        	}
         	if(cpmc!=null && !"".equals(cpmc.trim())){
            	sql.append(" AND ( CPMC like concat(concat('%',:oldcpmc),'%')) ");    		
        	}
        	if(sblb!=null && !"".equals(sblb)){
            	sql.append(" AND TBTYPE=:oldsblb ");    		
        	}
        	if(jcejg!=null && !"".equals(jcejg.trim())){
        		sql.append(" AND JCE.name=:oldjcejg ");    		
        	} 
        	if(isnew!=null && "Y".equals(isnew)){
            	sql.append(" AND (ISNEW='Y' or ISNEW='J')");    		
        	}
        	if(isnew!=null && "N".equals(isnew)){
            	sql.append(" AND (ISNEW ='N' or ISNEW is null) ");    		
        	} 
    	}
    	
    	sql.append(" ORDER BY PC DESC ");
    	
    	Query query = entityManager.createNativeQuery(sql.toString());
    	if(cpxh!=null && !"".equals(cpxh.trim())){
    		query.setParameter("cpxh", cpxh);
    	}
    	if(cpmc!=null && !"".equals(cpmc.trim())){
    		query.setParameter("cpmc", cpmc);
    	}
    	if(pc!=null && !"".equals(pc.trim())){
    		query.setParameter("pc", pc);
    	}
    	if(jcejg!=null && !"".equals(jcejg.trim())){
    		query.setParameter("jcejg", jcejg);
    	}
    	if(sblb!=null && !"".equals(sblb.trim())){
    		query.setParameter("sblb", sblb);
    	}
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			query.setParameter("qrStartTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			query.setParameter("qrEndTime", page.getEndTime());
		}  
		if(null!= viserID && viserID.intValue() > 10){
		//新增历史统计表（338之前的）
    	if(pc!=null && !"".equals(pc.trim())){
    		query.setParameter("oldpc", pc);
    	}
    	if(cpxh!=null && !"".equals(cpxh.trim())){
    		query.setParameter("oldcpxh", cpxh);
    	}
    	if(cpmc!=null && !"".equals(cpmc.trim())){
    		query.setParameter("oldcpmc", cpmc);
    	}
    	if(sblb!=null && !"".equals(sblb.trim())){
    		if("新产品".equals(sblb)){
    			sblb = "qjtjb";
    		}else if("变更扩展".equals(sblb)){
    			sblb = "kwkz";
    		}
    		query.setParameter("oldsblb", sblb);
    	}
    	if(jcejg!=null && !"".equals(jcejg.trim())){
    		query.setParameter("oldjcejg", jcejg);
    	}
	   }
    	
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
    	query.setFirstResult(page.getOffset());
        query.setMaxResults(page.getLimit());
        List<Map<String, Object>> list = query.getResultList();
        return list;
    }    
    
    
     /**
     * 按条件查询出所有的行数
     *
     * @param source  查询文件来源
     * @param qyid 
     * @param rkEndTime 
     * @param rkStartTime 
     * @param name  查询记录标题名称
     * @return
     */ 
    
    public Long findTotalCount(PageParam page,String cpxh,String cpmc, String pc, String qyid,String confirm,String sblb,String jcejg,String isnew ) {
    	StringBuffer sql = new StringBuffer();
    	sql.append("SELECT COUNT(*) FROM NERDS.Qjtjb G ");
    	sql.append(" WHERE G.QY_ID= '"+qyid+"' ");   
     	if(cpxh!=null && !"".equals(cpxh.trim())){
        	sql.append(" AND ( CPXH like concat(concat('%',:cpxh),'%')) ");    		
    	}
     	if(cpmc!=null && !"".equals(cpmc.trim())){
        	sql.append(" AND ( CPMC like concat(concat('%',:cpmc),'%')) ");    		
    	}
    	if(pc!=null && !"".equals(pc)){
        	sql.append(" AND PC=:pc ");    		
    	}
    	if(sblb!=null && !"".equals(sblb)){
        	sql.append(" AND SBLX=:sblb ");    		
    	}
    	if(jcejg!=null && !"".equals(jcejg.trim())){
    		sql.append(" AND JCEJGNAME=:jcejg ");    		
    	} 
    	if(confirm!=null && "1".equals(confirm)){
        	sql.append(" AND CONFIRM='1' ");    		
    	}
    	if(confirm!=null && "0".equals(confirm)){
        	sql.append(" AND (CONFIRM ='0' or CONFIRM is null) ");    		
    	}
    	if(isnew!=null && "Y".equals(isnew)){
        	sql.append(" AND ISNEW='Y' ");    		
    	}
    	if(isnew!=null && "N".equals(isnew)){
        	sql.append(" AND (ISNEW ='N' or ISNEW is null) ");    		
    	} 
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') >=:qrStartTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') <=:qrEndTime ");
		} 
    	Query query = entityManager.createNativeQuery(sql.toString());
    	if(cpxh!=null && !"".equals(cpxh.trim())){
    		query.setParameter("cpxh", cpxh);
    	}
    	if(cpmc!=null && !"".equals(cpmc.trim())){
    		query.setParameter("cpmc", cpmc);
    	}
    	if(pc!=null && !"".equals(pc.trim())){
    		query.setParameter("pc", pc);
    	}
    	if(jcejg!=null && !"".equals(jcejg.trim())){
    		query.setParameter("jcejg", jcejg);
    	}
    	if(sblb!=null && !"".equals(sblb.trim())){
    		query.setParameter("sblb", sblb);
    	}
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			query.setParameter("qrStartTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			query.setParameter("qrEndTime", page.getEndTime());
		} 
    	Long count = Long.parseLong(query.getSingleResult().toString());
        return count;
    }
	
    
    public Long findHistoryTotalCount(PageParam page,String cpxh,String cpmc, String pc, String qyid,String confirm,String sblb,String jcejg,String isnew ) {
    	StringBuffer sql = new StringBuffer();
    	sql.append("SELECT COUNT(*) FROM NERDS.Qjtjb G ");
    	sql.append(" WHERE G.QY_ID= '"+qyid+"' ");   
     	if(cpxh!=null && !"".equals(cpxh.trim())){
        	sql.append(" AND ( CPXH like concat(concat('%',:cpxh),'%')) ");    		
    	}
     	if(cpmc!=null && !"".equals(cpmc.trim())){
        	sql.append(" AND ( CPMC like concat(concat('%',:cpmc),'%')) ");    		
    	}
    	if(pc!=null && !"".equals(pc)){
        	sql.append(" AND PC=:pc ");    		
    	}
    	if(sblb!=null && !"".equals(sblb)){
        	sql.append(" AND SBLX=:sblb ");    		
    	}
    	if(jcejg!=null && !"".equals(jcejg.trim())){
    		sql.append(" AND JCEJGNAME=:jcejg ");    		
    	} 
    	if(confirm!=null && "1".equals(confirm)){
        	sql.append(" AND CONFIRM='1' ");    		
    	}
    	if(confirm!=null && "0".equals(confirm)){
        	sql.append(" AND (CONFIRM ='0' or CONFIRM is null) ");    		
    	}
    	if(isnew!=null && "Y".equals(isnew)){
        	sql.append(" AND ISNEW='Y' ");    		
    	}
    	if(isnew!=null && "N".equals(isnew)){
        	sql.append(" AND (ISNEW ='N' or ISNEW is null) ");    		
    	} 
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') >=:qrStartTime ");
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			sql.append(" AND TO_CHAR(G.CONFIRM_TIME, 'YYYY-MM-DD') <=:qrEndTime ");
		} 
    	Query query = entityManager.createNativeQuery(sql.toString());
    	if(cpxh!=null && !"".equals(cpxh.trim())){
    		query.setParameter("cpxh", cpxh);
    	}
    	if(cpmc!=null && !"".equals(cpmc.trim())){
    		query.setParameter("cpmc", cpmc);
    	}
    	if(pc!=null && !"".equals(pc.trim())){
    		query.setParameter("pc", pc);
    	}
    	if(jcejg!=null && !"".equals(jcejg.trim())){
    		query.setParameter("jcejg", jcejg);
    	}
    	if(sblb!=null && !"".equals(sblb.trim())){
    		query.setParameter("sblb", sblb);
    	}
		if(page.getStartTime()!=null && !"".equals(page.getStartTime())){
			query.setParameter("qrStartTime", page.getStartTime());
		}
		if(page.getEndTime()!=null && !"".equals(page.getEndTime())){
			query.setParameter("qrEndTime", page.getEndTime());
		} 
    	Long count = Long.parseLong(query.getSingleResult().toString());
    	
    	Long countOld =0l;
    	//只有定制版企业才显示338批次之前的统计表数据 
		//根据企业ID查询企业的版本号
		String sql_temp = "select VERSION_ID from retrieval.ret_users where username =:username ";
		Query queryTemp = entityManager.createNativeQuery(sql_temp.toString());
    	if(qyid!=null && !"".equals(qyid.trim())){
    		queryTemp.setParameter("username", qyid);
    	}
    	queryTemp.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
    	BigDecimal viserID = null;
        List<Map<String, Object>> listTemp = queryTemp.getResultList();
        if(listTemp.size()>0){
        	 viserID = (BigDecimal) listTemp.get(0).get("VERSION_ID");
        }
//        System.out.println(viserID);
    	if(null!= viserID && viserID.intValue() > 10){
        	//查询338及以后批次的统计表数量
        	StringBuffer sqlOld = new StringBuffer();
        	sqlOld.append("  SELECT count(1) ");
        	sqlOld.append(" FROM GGCAIN06.JCE_COMMINFO_ZK ZK ");
        	sqlOld.append(" LEFT JOIN (SELECT ID, DXBGBH FROM GGCAIN06.JCE_COMMINFO_ZK WHERE TBTYPE = 'DXBG') DX ");
        	sqlOld.append(" ON DX.ID = ZK.ID ");
        	sqlOld.append(" LEFT JOIN GGCAIN06.JCEJG JCE ");
        	sqlOld.append(" ON ZK.USERNAME = JCE.USERNAME ");
        	sqlOld.append(" WHERE 1=1 AND TBTYPE IN ('qjtjb','kwkz') ");
        	sqlOld.append(" AND QYMC LIKE '%%' ");
        	
        	if(!"adc".equals(qyid)){
        	sqlOld.append(" AND (USERNAME = '"+qyid+"' ");
        	sqlOld.append(" OR QY_ID      = '"+qyid+"')");
        	}
        	
        	//添加338及以后批的筛选条件
        	if(pc!=null && !"".equals(pc)){
            	sqlOld.append(" AND PC=:oldpc ");    		
        	}  	
         	if(cpxh!=null && !"".equals(cpxh.trim())){
            	sqlOld.append(" AND CPXH like concat(concat('%',:oldcpxh),'%')  ");    		
        	}
         	if(cpmc!=null && !"".equals(cpmc.trim())){
            	sqlOld.append(" AND ( CPMC like concat(concat('%',:oldcpmc),'%')) ");    		
        	}
        	if(sblb!=null && !"".equals(sblb)){
            	sqlOld.append(" AND TBTYPE=:oldsblb ");    		
        	}
        	if(jcejg!=null && !"".equals(jcejg.trim())){
        		sqlOld.append(" AND JCE.name=:oldjcejg ");    		
        	} 
        	if(isnew!=null && "Y".equals(isnew)){
        		sqlOld.append(" AND (ISNEW='Y' or ISNEW='J')");    		
        	}
        	if(isnew!=null && "N".equals(isnew)){
        		sqlOld.append(" AND (ISNEW ='N' or ISNEW is null) ");    		
        	} 
        	Query queryOld = entityManager.createNativeQuery(sqlOld.toString());
            //新增历史统计表（338之前的）
        	if(pc!=null && !"".equals(pc.trim())){
        		queryOld.setParameter("oldpc", pc);
        	}
        	if(cpxh!=null && !"".equals(cpxh.trim())){
        		queryOld.setParameter("oldcpxh", cpxh);
        	}
        	if(cpmc!=null && !"".equals(cpmc.trim())){
        		queryOld.setParameter("oldcpmc", cpmc);
        	}
        	if(sblb!=null && !"".equals(sblb.trim())){
        		if("新产品".equals(sblb)){
        			sblb = "qjtjb";
        		}else if("变更扩展".equals(sblb)){
        			sblb = "kwkz";
        		}
        		queryOld.setParameter("oldsblb", sblb);
        	}
        	if(jcejg!=null && !"".equals(jcejg.trim())){
        		queryOld.setParameter("oldjcejg", jcejg);
        	}
        	countOld = Long.parseLong(queryOld.getSingleResult().toString());
    	}

        return count +countOld ;
    }  
    
	/**   
	 * @Title: insertQjtjbInfo   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qjtjbinfo    设定文件   
	 * @return void    返回类型   
	 * @author ADC_ZH 
	 * @date 上午8:30:36 
	*/   
	public int insertQjtjbInfo(final List<QJTJB_INFO> qjtjbinfos,final String isNew) {
		int i=0;
		Map<String,Object> res = new HashMap<>();
    	StringBuffer sql = new StringBuffer();
    	sql.append(" INSERT INTO NERDS.QJTJB_INFO ");
    	sql.append(" (ID,QJTJB_ID,XMDH,JCXM,JYYJ,JYLB,STID,STXH,STBG,SCXM,SCBG,PZ,JYJG,XMSM,ISNEW,CREATE_TIME,QY_ID) VALUES ");
    	sql.append(" ( ?,       ?,   ?,   ?,   ?,   ?,   ?,   ?,   ?,   ?,   ?, ?,   ?,   ?,    ?,    sysdate,    ?)");
    	try {
    	int[] ooo= jdbcTemplate.batchUpdate(sql.toString(), new BatchPreparedStatementSetter() {
             public void setValues(PreparedStatement ps, int i) throws SQLException {
            	 QJTJB_INFO qjtjbinfo =qjtjbinfos.get(i);
                 ps.setString(1, qjtjbinfo.getId());
                 ps.setString(2, qjtjbinfo.getQjtjbid());
                 ps.setString(3, qjtjbinfo.getXmdh());
                 ps.setString(4, qjtjbinfo.getJcxm());
                 ps.setString(5, qjtjbinfo.getJyyj());
                 ps.setString(6, qjtjbinfo.getJylb());
                 ps.setString(7, qjtjbinfo.getStid());
                 ps.setString(8, qjtjbinfo.getStxh());
                 ps.setString(9, qjtjbinfo.getStbg());
                 ps.setString(10, qjtjbinfo.getScxm());
                 ps.setString(11, qjtjbinfo.getScbg());
                 ps.setString(12, qjtjbinfo.getPz());
                 ps.setString(13, qjtjbinfo.getJyjg());
                 ps.setString(14, qjtjbinfo.getXmsm());
                 ps.setString(15, isNew);
                 ps.setString(16, qjtjbinfo.getQY_ID());
             }

			@Override
			public int getBatchSize() {
				// TODO Auto-generated method stub
				return qjtjbinfos.size();
			}
         });
    	System.out.println(ooo.length);
    	i=ooo.length;  
     } catch (Exception e) { 
         e.printStackTrace();
         throw new AdcDaBaseException("数据保存错误");
     }
   	
     return i;
	}

	/**   
	 * @Title: insertQjtjb   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qjtjb    设定文件   
	 * @return void    返回类型   
	 * @author ADC_ZH 
	 * @date 上午8:30:48 
	*/   
	public Map<String,Object> insertQjtjb(QJTJB qjtjb) {
		if(StringUtils.isEmpty(qjtjb.getSBLX())){ 
	    	String str ="SELECT COUNT(*) FROM NERDS.CPSB_GS_ALL WHERE CPXH='"+qjtjb.getCPXH()+"' AND PC='"+qjtjb.getPC()+"'";
	    	Query query = entityManager.createNativeQuery(str);
	    	Long count = Long.parseLong(query.getSingleResult().toString());
	    	if(count>0){
	    		qjtjb.setSBLX("新产品");
	    	}else{
	    		qjtjb.setSBLX("变更扩展");
	    	}
		}
		Map<String,Object> res = new HashMap<>();
    	StringBuffer sql = new StringBuffer();
    	sql.append(" INSERT INTO NERDS.QJTJB ");
    	sql.append(" (ID,CPXH,PC,CPMC,SBLX,JCEJGNAME,QJTJB_MC,QJTJB_NEW_MC,CREATE_TIME,QY_ID ,CONFIRM,DEL_FLAG,ISNEW) VALUES ");
    	sql.append(" (:id, :cpxh,:pc,:cpmc,:sblx,:jcename ,:qjtjbmc ,:qjtjbnewmc ,sysdate   ,:qyid ,'0'    ,'0',:isnew)");
    	try {
          Query query = entityManager.createNativeQuery(sql.toString());
          query.setParameter("id", qjtjb.getID());
          query.setParameter("cpxh", qjtjb.getCPXH());
          query.setParameter("pc", qjtjb.getPC());
          query.setParameter("cpmc", qjtjb.getCPMC());
          query.setParameter("sblx", qjtjb.getSBLX());
          query.setParameter("jcename", qjtjb.getJCEJGNAME());
          query.setParameter("qjtjbmc", qjtjb.getQJTJB_MC());
          query.setParameter("qjtjbnewmc", qjtjb.getQJTJB_NEW_MC());
          query.setParameter("qyid", qjtjb.getQY_ID()); 
          query.setParameter("isnew", qjtjb.getISNEW()); 
          if (query.executeUpdate() == 1){
              res.put("success", "1");
              res.put("msg", "保存成功");
          }else{
          	res.put("success", "0");
              res.put("msg", "保存失败");
          }
      } catch (Exception e) {
          res.put("success", "0");
          res.put("msg", e.toString());
          e.printStackTrace();
          System.out.println("---------------------------"+qjtjb.getID());
      }
      return res;
	}

	/**   
	 * @Title: delById   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @return    设定文件   
	 * @return String    返回类型   
	 * @author ADC_ZH 
	 * @date 下午1:54:11 
	*/   
	public String delById(String id) {
		Map<String,Object> res = new HashMap<>();
    	StringBuffer sql1 = new StringBuffer();
    	sql1.append(" DELETE FROM NERDS.QJTJB WHERE ID=:id ");
    	StringBuffer sql2 = new StringBuffer();
    	sql2.append(" DELETE FROM NERDS.QJTJB_INFO WHERE QJTJB_ID=:id ");
    	try {
            Query query1 = entityManager.createNativeQuery(sql1.toString());
            query1.setParameter("id", id);
            Query query2 = entityManager.createNativeQuery(sql2.toString());
            query2.setParameter("id", id);
            int ZRIN=query1.executeUpdate();
            int DETAIL=query2.executeUpdate();
            return null;
    	} catch (Exception e) { 
            e.printStackTrace();
            return id;
        }
    	
	}

	/**   
	 * @Title: confirm   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @return    设定文件   
	 * @return int    返回类型   
	 * @author ADC_ZH 
	 * @date 下午1:58:10 
	*/   
	@Modifying
	public int confirm(String id) {
		StringBuffer sql = new StringBuffer();
    	sql.append(" UPDATE NERDS.QJTJB SET CONFIRM='1',CONFIRM_TIME=SYSDATE  WHERE ID='"+id+"'");
        Query query = entityManager.createNativeQuery(sql.toString()); 
        int ZRIN=query.executeUpdate();
		return ZRIN;
	}
	
	
	public List<Map<String, Object>> findHistoryQjtjbBasicInfo(String id) {
		StringBuffer sql = new StringBuffer();
    	sql.append(" select qymc,cpmc,qy_id,username,cpsb,jcejg_cllb,cpxh,fdjlx,jysm,jkjpd,pz,sh,bz,jce.name as jcjgname,ycdz,ycsl,y45pic,qjtjb_bh,syfa_bh,dxbgbh from ");
    	sql.append(" GGCAIN06.jce_comminfo_zk m ");
    	sql.append(" left join (select name,username as jcjgname from GGCAIN06.jcejg)jce on m.username = jce.jcjgname ");
    	sql.append(" where id=:id and (tbtype='qjtjb' or tbtype='kwkz') ");
    	Query query = entityManager.createNativeQuery(sql.toString()); 
    	query.setParameter("id", id);
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
        return list; 
	}
	
	
	

	/**   
	 * @Title: pc   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午4:42:13 
	*/   
	public List<Map<String, Object>> pc() {
		StringBuffer sql = new StringBuffer();
    	sql.append(" SELECT * FROM (select DISTINCT (TO_NUMBER(NVL(批次,0))) PC from RETRIEVAL.clcp_zk ");
    	sql.append(" ORDER BY PC DESC)  where PC>338 ");
//    	sql.append(" ORDER BY PC DESC)  where PC>156 ");
    	Query query = entityManager.createNativeQuery(sql.toString()); 
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
        return list;
	}

	public List<Map<String, Object>> oldpc() {
		StringBuffer sql = new StringBuffer();
    	sql.append(" SELECT * FROM (select DISTINCT (TO_NUMBER(NVL(批次,0))) PC from RETRIEVAL.clcp_zk ");
//    	sql.append(" ORDER BY PC DESC)  where PC>338 ");
    	sql.append(" ORDER BY PC DESC)  where PC>156 ");
    	Query query = entityManager.createNativeQuery(sql.toString()); 
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList();
        return list;
	}	
	
	
	/**   
	 * @Title: findQjtjbInfo   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @param isNew
	 * @param @return    设定文件   
	 * @return List<Map<String,Object>>    返回类型   
	 * @author ADC_ZH 
	 * @date 下午5:02:50 
	*/   
	public List<Map<String, Object>> findQjtjbInfo(String id, String isNew,String qyid) {
		StringBuffer sql = new StringBuffer();
    	sql.append(" SELECT  G.* ");
    	sql.append(" FROM NERDS.QJTJB_INFO G ");   
    	sql.append(" WHERE G.QY_ID= '"+qyid+"'");   
    	sql.append(" AND QJTJB_ID=:id ");    		
    	sql.append(" AND ISNEW=:isNew ");    		
    	sql.append(" ORDER BY G.XMDH  ");
    	Query query = entityManager.createNativeQuery(sql.toString());
        query.setParameter("id", id);
        query.setParameter("isNew", isNew);
    	 query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList(); 
//        List<QJTJB_INFO> listQJTJB_INFO = query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.aliasToBean(QJTJB_INFO.class)).list();;

        return list;
	}
	
	public List<Map<String, Object>> findHistoryQjtjbInfo(String id, String isNew,String qyid,String cplb) {
		StringBuffer sql = new StringBuffer();
		sql.append(" select b.seq,b.cname,b.jyyj,item_sqjylb,item_stcpxh,trim(item_stbgbh) item_stbgbh,a.item_scxms,trim(item_scbgbh) item_scbgbh,item_jyjg from ");
		String tableName = "N".equals(isNew)  ? "GGCAIN06.jce_qjbg_zk" : ("Y".equals(isNew) ? "GGCAIN06.jce_newe_qjbg_zk" : "GGCAIN06.jce_jiachun_qjbg_zk");
		sql.append(tableName);   
    	sql.append(" a left join GGCAIN06.jcexm b on a.item_ename = b.ename and b.cplb=:cplb  where a.jcbg_id=:id order by lpad(seq,2,'0'),ename ");   
    	Query query = entityManager.createNativeQuery(sql.toString());
        query.setParameter("cplb", cplb);
        query.setParameter("id", id);
    	query.unwrap(org.hibernate.SQLQuery.class).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        List<Map<String, Object>> list = query.getResultList(); 
        //处理报告编号  TODO deal
        List<Map<String, Object>> resultList = new ArrayList<Map<String, Object>>();
        for(Map<String, Object> map : list){
        	String stbgbh = (String) map.get("ITEM_STBGBH");
        	if(null!= stbgbh && !"".equals(stbgbh)){
        		List<String> praseBgbh = praseBgbh(stbgbh);
        		map.put("ITEM_STBGBH", praseBgbh);
        	}
        	String scbgbh = (String) map.get("ITEM_SCBGBH");
        	if(null!= scbgbh && !"".equals(scbgbh)){
        		List<String> praseBgbh = praseBgbh(scbgbh);
        		map.put("ITEM_SCBGBH", praseBgbh);
        	}
        	
        	resultList.add(map);
        }
        
        return resultList;
	}	
	
	/**
	 * 拆分报告编号成string数组
	 * @param bgbh 原始字符串
	 * @return
     */
	public List<String> praseBgbh(String bgbh){
		bgbh = bgbh.replaceAll("\\s*","").replaceAll("　", "").replaceAll(";",",").replaceAll("；",",").replaceAll("，",",");
		List<String> asList = Arrays.asList(bgbh.split(","));
		return Arrays.asList(bgbh.split(","));
	}

	/**   
	 * @Title: findQjtjbInfoCount   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @param isNew
	 * @param @return    设定文件   
	 * @return Long    返回类型   
	 * @author ADC_ZH 
	 * @date 下午5:02:56 
	*/   
	public Long findQjtjbInfoCount(String id, String isNew,String qyid) {
		StringBuffer sql = new StringBuffer();
    	sql.append("SELECT COUNT(*)   ");
    	sql.append(" FROM NERDS.QJTJB_INFO G ");   
    	sql.append(" WHERE G.QY_ID= '"+qyid+"'");   
    	sql.append(" AND QJTJB_ID=:id ");    		
    	sql.append(" AND ISNEW=:isNew ");   
     	 
    	Query query = entityManager.createNativeQuery(sql.toString());
    	query.setParameter("id", id);
        query.setParameter("isNew", isNew);
    	Long count = Long.parseLong(query.getSingleResult().toString());
        return count;
	}

	public Long findHistoryQjtjbInfoCount(String id, String isNew,String qyid,String cplb) {
    	StringBuffer sql = new StringBuffer();
		sql.append(" select COUNT(*) from ");
		String tableName = "N".equals(isNew)  ? "GGCAIN06.jce_qjbg_zk" : ("Y".equals(isNew) ? "GGCAIN06.jce_newe_qjbg_zk" : "GGCAIN06.jce_jiachun_qjbg_zk");
		sql.append(tableName);   
    	sql.append(" a left join GGCAIN06.jcexm b on a.item_ename = b.ename and b.cplb=:cplb  where a.jcbg_id=:id order by lpad(seq,2,'0'),ename ");   
    	Query query = entityManager.createNativeQuery(sql.toString());
        query.setParameter("cplb", cplb);
        query.setParameter("id", id);
        Long count = Long.parseLong(query.getSingleResult().toString());
        return count;
	}	
	
	
	/**   
	 * @Title: qjtjbInfoEdit   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param listqjtjbInfo
	 * @param @return    设定文件   
	 * @return int    返回类型   
	 * @author ADC_ZH 
	 * @date 上午8:54:53 
	*/   
	public int qjtjbInfoEdit(final List<QJTJB_INFO> listqjtjbInfo) {  
    	int ZRIN=0;
    	try {
    		for(QJTJB_INFO qjtjbinfo:listqjtjbInfo){
    			StringBuffer sql = new StringBuffer();
    			sql.append(" UPDATE NERDS.QJTJB_INFO SET ");
    			if(!StringUtils.isEmpty(qjtjbinfo.getJylb())){    				
    				sql.append(" JYLB = :jylb, ");
    			}
    			if(!StringUtils.isEmpty(qjtjbinfo.getStid())){    				
    				sql.append(" STID = :stid, ");
    			}
    			if(!StringUtils.isEmpty(qjtjbinfo.getStxh())){    				
    				sql.append(" STXH = :stxh, ");
    			}  
    			if(!StringUtils.isEmpty(qjtjbinfo.getStbg())){    				
    				sql.append(" STBG = :stbg, ");
    			}  
    			if(!StringUtils.isEmpty(qjtjbinfo.getScxm())){    				
    				sql.append(" SCXM = :scxm, ");
    			} 
    			if(!StringUtils.isEmpty(qjtjbinfo.getScbg())){    				
    				sql.append(" SCBG = :scbg, ");
    			} 
    			if(!StringUtils.isEmpty(qjtjbinfo.getPz())){    				
    				sql.append(" PZ = :pz, ");
    			} 
    			if(!StringUtils.isEmpty(qjtjbinfo.getJyjg())){    				
    				sql.append(" JYJG = :jyjg, ");
    			} 
    			if(!StringUtils.isEmpty(qjtjbinfo.getXmsm())){    				
    				sql.append(" XMSM = :xmsm, ");
    			}
    	    	sql.append(" CREATE_TIME=SYSDATE "); 
    			sql.append(" WHERE ID=:id");   
    			Query query = entityManager.createNativeQuery(sql.toString());
    			if(!StringUtils.isEmpty(qjtjbinfo.getJylb())){    				
    				query.setParameter("jylb", qjtjbinfo.getJylb());
    			}
    			if(!StringUtils.isEmpty(qjtjbinfo.getStid())){    				
    				query.setParameter("stid", qjtjbinfo.getStid());
    			}
    			if(!StringUtils.isEmpty(qjtjbinfo.getStxh())){    				
    				query.setParameter("stxh", qjtjbinfo.getStxh());
    			}  
    			if(!StringUtils.isEmpty(qjtjbinfo.getStbg())){    				
    				query.setParameter("stbg", qjtjbinfo.getStbg());
    			}  
    			if(!StringUtils.isEmpty(qjtjbinfo.getScxm())){    				
    				query.setParameter("scxm", qjtjbinfo.getScxm());
    			} 
    			if(!StringUtils.isEmpty(qjtjbinfo.getScbg())){    				
    				query.setParameter("scbg", qjtjbinfo.getScbg());
    			} 
    			if(!StringUtils.isEmpty(qjtjbinfo.getPz())){    				
    				query.setParameter("pz", qjtjbinfo.getPz());
    			} 
    			if(!StringUtils.isEmpty(qjtjbinfo.getJyjg())){    				
    				query.setParameter("jyjg", qjtjbinfo.getJyjg());
    			} 
    			if(!StringUtils.isEmpty(qjtjbinfo.getXmsm())){    				
    				query.setParameter("xmsm", qjtjbinfo.getXmsm());
    			}
     			query.setParameter("id", qjtjbinfo.getId());
    			ZRIN+=query.executeUpdate();
    		}
    	
     } catch (Exception e) { 
         e.printStackTrace();
     }
   	
     return ZRIN;
		
    	 
	}

	/**   
	 * @Title: qjtjbEdit   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param qjtjb
	 * @param @return    设定文件   
	 * @return int    返回类型   
	 * @author ADC_ZH 
	 * @date 上午9:30:14 
	*/   
	public int qjtjbEdit(QJTJB qjtjb) {
		StringBuffer sql = new StringBuffer();
    	sql.append(" UPDATE NERDS.QJTJB SET ");

    	if(qjtjb.getPC()!=null && !"".equals(qjtjb.getPC())){
        	sql.append(" PC=:pc, ");
    	}
    	if(qjtjb.getSBLX() !=null && !"".equals(qjtjb.getSBLX())){
    		sql.append(" SBLX=:sblx, ");
    	} 
    	if(qjtjb.getJCEJGNAME()!=null && !"".equals(qjtjb.getJCEJGNAME())){
    		sql.append(" JCEJGNAME=:jcename, ");
    	}
    	if(qjtjb.getISNEW()!=null && !"".equals(qjtjb.getISNEW())){
    		sql.append(" ISNEW=:isNew, ");
    	}
    	if(qjtjb.getQJTJB_MC()!=null && !"".equals(qjtjb.getQJTJB_MC())){
    		sql.append(" QJTJB_MC=:tjbmc, ");
    	}
    	if(qjtjb.getQJTJB_NEW_MC()!=null && !"".equals(qjtjb.getQJTJB_NEW_MC())){
    		sql.append(" QJTJB_NEW_MC=:tjbnewmc, ");
    	}
    	sql.append(" CREATE_TIME=SYSDATE "); 
    	sql.append(" WHERE ID=:id ");
        Query query = entityManager.createNativeQuery(sql.toString()); 
        if(qjtjb.getPC()!=null && !"".equals(qjtjb.getPC())){
            query.setParameter("pc", qjtjb.getPC());
    	}
    	if(qjtjb.getSBLX() !=null && !"".equals(qjtjb.getSBLX())){
            query.setParameter("sblx", qjtjb.getSBLX() );
    	} 
    	if(qjtjb.getJCEJGNAME()!=null && !"".equals(qjtjb.getJCEJGNAME())){
            query.setParameter("jcename", qjtjb.getJCEJGNAME());
    	}
    	if(qjtjb.getISNEW()!=null && !"".equals(qjtjb.getISNEW())){
            query.setParameter("isNew", qjtjb.getISNEW());
    	}
    	if(qjtjb.getQJTJB_MC()!=null && !"".equals(qjtjb.getQJTJB_MC())){
            query.setParameter("tjbmc", qjtjb.getQJTJB_MC());
    	}
    	if(qjtjb.getQJTJB_NEW_MC()!=null && !"".equals(qjtjb.getQJTJB_NEW_MC())){
            query.setParameter("tjbnewmc", qjtjb.getQJTJB_NEW_MC());
    	} 
    	query.setParameter("id", qjtjb.getID()); 
        int ZRIN=query.executeUpdate();
		return ZRIN;
	}

	/**   
	 * @Title: delQjtjbInfo   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param id
	 * @param @param string    设定文件   
	 * @return void    返回类型   
	 * @author ADC_ZH 
	 * @date 下午5:55:24 
	*/   
	public void delQjtjbInfo(String id, String isNew) {
		Map<String,Object> res = new HashMap<>(); 
    	StringBuffer sql2 = new StringBuffer();
    	sql2.append(" DELETE FROM NERDS.QJTJB_INFO WHERE QJTJB_ID=:id  AND ISNEW=:isNew ");
    	try { 
            Query query2 = entityManager.createNativeQuery(sql2.toString());
            query2.setParameter("id", id);
            query2.setParameter("isNew", isNew);
            int DETAIL=query2.executeUpdate();
     	} catch (Exception e) { 
            e.printStackTrace();
         }
		
	}

	/**   
	 * @Title: backData   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param gg
	 * @param @param qyid
	 * @param @return    设定文件   
	 * @return int    返回类型   
	 * @author ADC_ZH 
	 * @date 上午10:45:38 
	*/   
	public int backData(String gg, String qyid) {
		StringBuffer sql = new StringBuffer();
    	sql.append(" UPDATE NERDS.QJTJB SET CONFIRM='0', CONFIRM_TIME= ''  WHERE ID=:id ");
        Query query = entityManager.createNativeQuery(sql.toString()); 
		query.setParameter("id", gg); 
        int ZRIN=query.executeUpdate();
		return ZRIN;
	}

	/**   
	 * @Title: checkTjbStatus   
	 * @Description: TODO(这里用一句话描述这个方法的作用)    
	 * @param @param cpxh
	 * @param @param pc
	 * @param @return    设定文件   
	 * @return Long    返回类型   
	 * @author ADC_ZH 
	 * @date 上午10:34:52 
	*/   
	public Long checkTjbStatus(String cpxh, String pc,String qyid) {
		String str ="SELECT COUNT(*) FROM NERDS.QJTJB WHERE CPXH='"+cpxh+"' AND PC='"+pc+"' AND QY_ID='"+qyid+"'";
    	Query query = entityManager.createNativeQuery(str);
    	Long count = Long.parseLong(query.getSingleResult().toString());
		return count;
	}

}
